]> git.proxmox.com Git - pve-installer.git/blobdiff - unconfigured.sh
bump version to 8.1.1
[pve-installer.git] / unconfigured.sh
index da611b095da118e7f23a632ae943dbefbddfd6e5..6b3a8bf2f63568dc2aa5b935cb176bdc3740a6b8 100755 (executable)
@@ -6,11 +6,19 @@ trap "err_reboot" ERR
 
 parse_cmdline() {
     proxdebug=0
+    proxtui=0
+    serial=0
     # shellcheck disable=SC2013 # per word splitting is wanted here
     for par in $(cat /proc/cmdline); do
         case $par in
             proxdebug)
-            proxdebug=1
+                proxdebug=1
+            ;;
+            proxtui)
+                proxtui=1
+            ;;
+            console=ttyS*)
+                serial=1
             ;;
         esac
     done;
@@ -24,8 +32,8 @@ eject_and_reboot() {
     iso_dev=$(awk '/ iso9660 / {print $1}' /proc/mounts)
 
     for try in 5 4 3 2 1; do
-        echo "unmounting all"
-        if umount -a; then
+        echo "unmounting ISO"
+        if umount -v -a --types iso9660; then
             break
         fi
         if test -n $try; then
@@ -35,13 +43,17 @@ eject_and_reboot() {
     done
 
     if [ -n "$iso_dev" ]; then
-        eject "$iso_dev"
+        eject "$iso_dev" || true # cannot really work currently, don't care
     fi
 
     umount -l -n /dev
 
     echo "rebooting - please remove the ISO boot media"
     sleep 3
+    reboot -nf
+    sleep 5
+    echo "trigger reset system request"
+    # we do not expect the reboot above to fail, so rather to avoid kpanic when pid 1 exits
     echo b > /proc/sysrq-trigger
     sleep 100
 }
@@ -63,6 +75,9 @@ real_reboot() {
         echo "done."
     fi
 
+    # just to be sure
+    sync
+
     umount -l -n /target >/dev/null 2>&1
     umount -l -n /dev/pts
     umount -l -n /dev/shm
@@ -125,6 +140,7 @@ if [ -d /sys/firmware/efi ]; then
     mount -n -t efivarfs efivarfs /sys/firmware/efi/efivars
 fi
 mount -n -t tmpfs tmpfs /run
+mkdir -p /run/proxmox-installer
 
 parse_cmdline
 
@@ -176,10 +192,12 @@ fi
 # we use a trimmed down debootstrap so make busybox tools available to compensate that
 busybox --install -s || true
 
+setupcon || echo "setupcon failed, TUI rendering might be garbled - $?"
+
 if [ $proxdebug -ne 0 ]; then
     /sbin/agetty -o '-p -- \\u' --noclear tty9 &
     printf "\nDropping in debug shell before starting installation\n"
-    echo "type exit or CTRL-D to continue and start the installation wizard"
+    echo "type 'exit' or press CTRL + D to continue and start the installation wizard"
     debugsh || true
 fi
 
@@ -188,13 +206,26 @@ echo -n "Attempting to get DHCP leases... "
 dhclient -v
 echo "done"
 
-echo -n "Starting chrony for opportunistic time-sync... "
+echo "Starting chrony for opportunistic time-sync... "
 chronyd || echo "starting chrony failed ($?)"
 
 echo "Starting a root shell on tty3."
 setsid /sbin/agetty -a root --noclear tty3 &
 
-xinit -- -dpi "$DPI" >/dev/tty2 2>&1
+/usr/bin/proxmox-low-level-installer dump-env
+
+if [ $proxtui -ne 0 ]; then
+    if [ "$serial" -ne 0 ]; then
+        echo "Setting terminal size to 80x24 for serial install"
+        stty columns 80 rows 25
+    fi
+
+    echo "Starting the TUI installer"
+    /usr/bin/proxmox-tui-installer 2>/dev/tty2
+else
+    echo "Starting the installer GUI - see tty2 (CTRL+ALT+F2) for any errors..."
+    xinit -- -dpi "$DPI" >/dev/tty2 2>&1
+fi
 
 # just to be sure everything is on disk
 sync